package com.example.beijing_daxing.base;

import android.annotation.SuppressLint;
import android.app.ProgressDialog;
import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.Window;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;

import com.example.beijing_daxing.R;
import com.google.gson.Gson;
import com.handheld.uhfr.*;
import com.uhf.api.cls.Reader;

import java.util.List;

import okhttp3.MediaType;

public abstract class BaseActivity extends AppCompatActivity {
    // public static String url = "http://192.168.0.102:8090/api";
    // public static String url = "http://192.168.42.239:8090/api";
    public static String url = "http://119.45.202.115:8090/api";
    public ProgressDialog dialog;
    public Gson gson;
    public MediaType JSON = MediaType.parse("application/json; charset=utf-8");
    public UHFRManager uhfLongerManager;
    private MediaPlayer mediaPlayer;
    public MyReceiver myReceiver;
    public Intent broadcastIntent;

    @SuppressLint("UnspecifiedRegisterReceiverFlag")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        gson = new Gson();
        initDialog();
        initSan();
        broadcastIntent = new Intent("android.rfid.FUN_KEY");
        broadcastIntent.putExtra("keydown", false);
        // broadcastIntent.setComponent(new ComponentName("com.example.beijing_daxing",".base.BaseActivity$MyReceiver"));
    }
    // private long readTime = 0;

    public class MyReceiver extends BroadcastReceiver {

        @Override
        public void onReceive(Context context, Intent intent) {

            var keydown = intent.getBooleanExtra("keydown", false);

            Log.e("TAG", "接收到广播:" + keydown);
            if (!keydown) {
                // readTime = System.currentTimeMillis();
                sanEpc();
            }
        }
    }
    public void  sanEpc(){
        List<Reader.TAGINFO> strings = uhfLongerManager.tagInventoryRealTime();
        // Log.e("TAG", "驱动" + (uhfLongerManager == null));
        if (strings == null || strings.isEmpty()) {
            return;
        }

        mediaPlayer.start();
        sanRfid(strings);
    }
    private void initDialog() {
        dialog = new ProgressDialog(this);
        dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
        dialog.setCanceledOnTouchOutside(false);
        dialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
        dialog.setMessage("请求网络...");
    }

    private void initSan() {
        uhfLongerManager = MyApplication.getUhfLongerManager();
        // intentFilter.addAction("android.intent.action.FUN_KEY");

        uhfLongerManager.asyncStartReading();

        myReceiver = new MyReceiver();
        IntentFilter intentFilter = new IntentFilter();
        intentFilter.addAction("android.rfid.FUN_KEY");
        registerReceiver(myReceiver, intentFilter);
        mediaPlayer = MediaPlayer.create(this, R.raw.msg);
    }

    public void setPower(int power){
        Reader.READER_ERR readerErr = uhfLongerManager.setPower(power, power);
        Log.e("TAG", "setPower:" + readerErr.name());
        Log.e("TAG", "readPower:" + uhfLongerManager.getPower()[0]);
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        unregisterReceiver(myReceiver);
    }


    protected abstract void sanRfid(List<Reader.TAGINFO> epcs);
}